#Molly Fane --- Fall, 2015 --- Math 198

#This program graphs a 3D surface using openGL and python.



#The input is a function with only real values on the specified domain of x and y, solved for z
#the input must be python-readable, so you must use pow(x,2) instead of x^2.
#You can also use the functions from math, such as math.sin() or math.pi



from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
import math
import sys

vertices = []
shadowVerts = []
#edges = []


#-----------------------------------------------

#Point of Light coordinates
Lx = 6
Ly = 0
Lz = 25

#Plane definitions
nx = 0
ny = 0
nz = 1
d = -20
planeLength = 30

#define range for y
yInit = -2
yRange = 4
yFin = yInit + yRange
deltaY = .3
y = yInit

#define range for x
xInit = -2
xRange = 4
xFin = xInit + xRange
deltaX = .3
x = xInit

#defines z as in z = f(x,y)
z = 0
#following two lines define the index variables of our coordinates-- coor at (yinit,xinit) a = 0 and b = 0
a = 0
b = 0

#INSTRUCTIONS ----- these are printed before the input line comes up
print("Shadow2: Function and Drop Shadow Grapher, Molly Fane, Math 198, Fall 2015")
print("")
print("This is a program that graphs a plane, a point of light, a function, and the resulting drop shadow.")
print("")
print("Please input a function. This function must be of the form z = f(x,y).")
print("IMPORTANT: Use python and math.py functions in referencing mathematical functions. References include: abs(), math.cos(), math.sinh(), math.sqrt(), math.pi, math.e")
print("IMPORTANT: Use * to denote multiplication, / to denote division")
print("IMPORTANT: exponents may be written in two different ways: eg. x to the power of 2 may be written as pow(x,2) or x**2")
print("IMPORTANT: you may NOT devide by zero and you may NOT take the fractional exponant of a negative number")
print("")
print("Examples of functions to look at:")
print("---> Monkey Saddle: pow(x,3)+3*pow(y,2)*x")
print("---> Egg Carton: math.sin(x*y)")
print("---> Cone: math.sqrt(pow(x,2) + pow(y,2))")
print("---> Saddle: x*y")
print("---> Drop in Still Water: sin(pow(x,2)+pow(y,2))")
print("")
print("USE QUOTES AROUND THE FUNCTION YOU INPUT!!!! It must be entered as a string.")

#INPUTS
funcIn = input("z = ")#asks for input function -- MUST USE math.sin, math.cosh... etc!
#END INPUTS

#holds x constant, then draws that trace as y increases by deltaY until y goes from yInit to yFin
#.. then repeats this process for x = x + deltaX until x goes from xInit to xFin

while(x < deltaX + xFin): #loop to hold x constant and then make a trace in zy-plane and then increase x
    y = yInit
    b = 0
    while(y < deltaY + yFin): # <--- loop that makes vertices for trace in zy-plane
        z = eval(funcIn)
        vertices.append([x,y,z,a,b])
        y = y + deltaY
        b = b + 1
    x = x + deltaX
    a = a + 1
#---------------------------------------------    
"""def drawEdges():
    vertex = 0
    edge = 0
    glBegin(GL_LINES)
    while(vertex < len(vertices)-1):
        if(vertices[vertex][0]== vertices[vertex+1][0]):
            glVertex3fv(vertices[vertex])
            glVertex3fv(vertices[vertex+1])
        vertex = vertex + 1
    glEnd()"""
def drawQuads(vertsList):
    quadsRendered = 0 #keeps track of the number of quadrilaterals you have mucking every thing up
    aLocal = 0
    bLocal = 0
    glBegin(GL_QUADS)
    glColor3f(0,0,10)
    while(aLocal < math.floor(xRange/deltaX)-1):
        bLocal = 0
        while(bLocal < math.floor(yRange/deltaY)-1):
            #little color edit before the quad is entered
            if(vertsList == vertices):
                lastVertex = searchForAandB(aLocal,bLocal,vertsList)
                glColor3f(1/(abs(.75*lastVertex[2])+1),0,1/(abs(.5*lastVertex[2])+1)) #as z increases, the color darkens --> pretty sweet style.
            if(vertsList == shadowVerts):
               glColor3f(0.0,0.0,0.0) #shadows should be atleast grey
               
            #finds the vertices at the correct indices for the quad to appear correctly
            glVertex3fv(searchForAandB(aLocal,bLocal,vertsList))            
            glVertex3fv(searchForAandB(aLocal+1,bLocal,vertsList))
            glVertex3fv(searchForAandB(aLocal+1,bLocal+1,vertsList))
            glVertex3fv(searchForAandB(aLocal,bLocal+1,vertsList))
            
            quadsRendered = quadsRendered +1
            bLocal = bLocal+1
        aLocal = aLocal+1
    glEnd()
def searchForAandB(aLocal,bLocal,vertsList):
    counter = 0
    while(counter < len(vertsList)-1):
        if(vertsList[counter][3] == aLocal and vertsList[counter][4]== bLocal):
            return [vertsList[counter][0],vertsList[counter][1],vertsList[counter][2]]
        counter = counter + 1

def defineShadow():
    counter = 0
    while(counter < len(vertices)):
        Px = vertices[counter][0]
        Py = vertices[counter][1]
        Pz = vertices[counter][2]
        if(nx*(Px-Lx)+ny*(Py-Ly)+nz*(Pz-Lz) != 0):
            tParameter = .999*(d-nx*Lx-ny*Ly-nz*Lz)/(nx*(Px-Lx)+ny*(Py-Ly)+nz*(Pz-Lz))#there was a float error here that was fixed with using 1.* (...)making the whole expression as a float
            Sx = (Px-Lx)*tParameter + Lx
            Sy = (Py-Ly)*tParameter + Ly
            Sz = (Pz-Lz)*tParameter + Lz
            shadowVerts.append([Sx,Sy,Sz,vertices[counter][3],vertices[counter][4]])
            counter = counter +1
        else:
            print("This combination of light, plane and function returns and infinte shadow")
            sys.exit("Error Message")
            
def drawAxis():
    glBegin(GL_LINES)

    glColor3f(1.0,0.0,0.0)
    glVertex3f(0-xRange/2,0,0)#sets x axis
    glVertex3f(xRange/2,0,0)

    glColor3f(0.0,1.0,0.0)
    glVertex3f(0,0-xRange/2,0)#sets y axis
    glVertex3f(0,xRange/2,0)

    glColor3f(0.0,0.0,1.0)
    glVertex3f(0,0,0-xRange/2)#sets z axis
    glVertex3f(0,0,xRange/2)

    glColor3f(1.0,1.0,1.0)

    glEnd()

def drawPlane():
    glBegin(GL_QUADS)
    glColor3f(0.721568,.721568,0.721568)
    glVertex3f(planeLength/2,planeLength/2,(d-(planeLength/2)*nx-(planeLength/2)*ny)/nz)
    glVertex3f(planeLength/2,-planeLength/2,(d-(planeLength/2)*nx-(-1*planeLength/2)*ny)/nz)
    glVertex3f(-planeLength/2,-planeLength/2,(d-(-1*planeLength/2)*nx-(-1*planeLength/2)*ny)/nz)
    glVertex3f(-planeLength/2,planeLength/2,(d-(-1*planeLength/2)*nx-(planeLength/2)*ny)/nz)
    glEnd()

#This code just makes an asterisk in the sky at point (Lx,Ly,Lz)
def drawLight():
    dL = .1
    glBegin(GL_LINES)
    glColor3f(1,1,0)
    
    #variables got mixed up a little
    #pX, pY, and pZ are local and are the same as global values Lx, Ly, Lz
    pX = Lx
    pY = Ly
    pZ = Lz

    glVertex3f(pX-dL,pY-dL,pZ)
    glVertex3f(pX+dL,pY+dL,pZ)

    glVertex3f(pX+dL,pY-dL,pZ)
    glVertex3f(pX-dL,pY+dL,pZ)

    glVertex3f(pX-dL,pY,pZ)
    glVertex3f(pX+dL,pY,pZ)

    glVertex3f(pX,pY-dL,pZ)
    glVertex3f(pX,pY+dL,pZ)

    glVertex3f(pX,pY-dL,pZ-dL)
    glVertex3f(pX,pY+dL,pZ+dL)

    glVertex3f(pX,pY-dL,pZ+dL)
    glVertex3f(pX,pY+dL,pZ-dL)

    glVertex3f(pX,pY,pZ-dL)
    glVertex3f(pX,pY,pZ+dL)

    glVertex3f(pX-dL,pY,pZ-dL)
    glVertex3f(pX+dL,pY,pZ+dL)

    glVertex3f(pX+dL,pY,pZ-dL)
    glVertex3f(pX-dL,pY,pZ+dL)


    glEnd()
def KeyBoardControls(key,x,y):
    #Keyboard rotate object controls
    
        #ROTATE ABOUT X AXIS
        if(key == "i"):
            glRotatef(-1,1,0,0)
        if(key == "k"):
            glRotatef(1,1,0,0)
            
        #ROTATE ABOUT Y AXIS    
        if(key == "j"):
            glRotatef(-.5,0,1,0)
        if(key == "l"):
            glRotatef(.5,0,1,0)

        #ROTATE ABOUT Z AXIS    
        if(key == "u"):
            glRotatef(.5,0,0,1)
        if(key == "o"):
            glRotatef(-.5,0,0,1)

        #TRANSLATE ALONG Z AXIS    
        if(key == "w"):#W KEY
            glTranslatef(0.0,0.0, .1)
        if(key == "s"):#S KEY
            glTranslatef(0.0,0.0, -.1)

        #TRANSLATE ALONG Y AXIS    
        if(key == "a"):#A KEY
            glTranslatef(0.0,.1,0.0)
        if(key == "d"):#D KEY
            glTranslatef(0.0,-.1, 0.0)

        #TRANSLATE ALONG X AXIS    
        if(key == "q"):#Q KEY
            glTranslatef(.1,0.0,0.0)
        if(key == "e"):#E KEY
            glTranslatef(-.1,0.0, 0.0)
    

def idle():
    glutPostRedisplay()

def main():
    defineShadow()
    glutInit(sys.argv)
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH)
    display = (1000,800)
    glutInitWindowSize(display[0],display[1])
    glutCreateWindow("Function Draw")
    glutDisplayFunc(draw)
    gluPerspective(45, (display[0]/display[1]), 0.1, 100.0)
    glEnable(GL_DEPTH_TEST)
    glTranslatef(0.0,7.0, -30)
    glRotatef(-45,1,0,0)
    glutIdleFunc(idle)
    glutKeyboardFunc(KeyBoardControls)
    glutMainLoop()

def draw():    
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    drawQuads(vertices)
    drawQuads(shadowVerts)
    #drawEdges()
    drawAxis()
    drawPlane()
    drawLight()
    glutSwapBuffers()

main()

